/*
  authClient.c
  Nafees Bin Zafar <nafees@acm.org>

  talks to the authd server to verify logins.

  have to link to socket and nsl libraries when compiling
  under solaris
*/


#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>

int main(int argc, char** argv) {
  int s;
  int i = 0;
  struct sockaddr_in server;
  struct hostent* hp;
  char insize[2];
  char buf[1024];
  char sendbuf[28];

  if (argc < 5) {
    printf ("Authentication Error\n"
	    "Usage: %s <host> <port> <username> <password>\n",
	    argv[0]);
    exit (-1);
  }

  /* set up authentication string: username password */
  sprintf (sendbuf, "%s %s\n", argv[3], argv[4]);
  
  /* set up the socket properties */
  s = socket(AF_INET, SOCK_STREAM, 0 );
  server.sin_family = AF_INET;
  hp = gethostbyname(argv[1]);
  bcopy( hp->h_addr, &server.sin_addr, hp->h_length);
  server.sin_port = htons(atoi(argv[2]));
  
  connect(s, &server, sizeof(server));
  write (s, sendbuf, strlen(sendbuf));
  bzero(buf, sizeof(buf));
  read (s, buf, sizeof(buf));
  close (s);

  printf ("%s\n", (buf[0] == 48 ? "Authentication Error" : buf));
  fflush(stdout);

  return 0;
}

