/*
  authd-inetd.c
  Nafees Bin Zafar <nafees@acm.org>
  
  Server to verify logins.  It is to be invoked by inetd,
  and thus has no networking code.

  may have to link to libcrypt to compile properly on some
  systems.
*/

#include <stdio.h>
#include <stdlib.h>
#include <pwd.h>
#include <string.h>
#include <errno.h>
#include <crypt.h>



/*
  struct passwd {
    char *pw_name;
    char *pw_passwd;
    uid_t     pw_uid;
    gid_t     pw_gid;
    char *pw_age;
    char *pw_comment;
    char *pw_gecos;
    char *pw_dir;
    char *pw_shell;
  };
*/


/* validate()
   returns user's real name if valid id/passwd provided
   null otherwise
   */
char* validate (char* uname, char* upass) {
  struct passwd* passwd;
  char usrDES[13];
  char salt[2];
  int result;
  char* tmptoken;
  
  passwd = getpwnam(uname);

  if (passwd == NULL)
    return (NULL);
  
  strncpy (salt, passwd -> pw_passwd, 2);
  sprintf (usrDES, "%s", crypt (upass, salt));

  if (strncmp (usrDES, passwd -> pw_passwd, 13) == 0) {
    tmptoken = strtok (passwd -> pw_gecos, ",");
    
    return tmptoken;
  }
  else
    return (NULL);
}


int main (int argc, char** argv) {
  char uname[1024];
  char upass[1024];
  char* result;

  {  /* connection handling, and processing */
    scanf("%s %s", uname, upass);
    
    if ((uname != NULL) && (upass != NULL)) {
      result = validate (uname, upass);
      fflush(stdout);
      if (result == NULL)
	printf ("%d", NULL);
      else if (result != NULL) {
	result[strlen(result)] = '\0';
	printf("%s", result);
      }
    }
  }
  fflush(stdout);
  return 0;
}
